config/routes.rb
Rails.application.routes.draw do
  
  namespace :admin do
      resources :chart_presets

      root to: "chart_presets#index"
    end
    
  resources :chart_presets do
    resources :chart_results
  end
  get 'public/index'
  root 'public#index'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/chart_preset.rb
class ChartPreset < ApplicationRecord
    has_many :chart_results
end

app/controllers/admin/chart_presets_controller.rb
module Admin
  class ChartPresetsController < Admin::ApplicationController
    # Overwrite any of the RESTful controller actions to implement custom behavior
    # For example, you may want to send an email after a foo is updated.
    #
    # def update
    #   super
    #   send_foo_updated_email(requested_resource)
    # end

    # Override this method to specify custom lookup behavior.
    # This will be used to set the resource for the `show`, `edit`, and `update`
    # actions.
    #
    # def find_resource(param)
    #   Foo.find_by!(slug: param)
    # end

    # The result of this lookup will be available as `requested_resource`

    # Override this if you have certain roles that require a subset
    # this will be used to set the records shown on the `index` action.
    #
    # def scoped_resource
    #   if current_user.super_admin?
    #     resource_class
    #   else
    #     resource_class.with_less_stuff
    #   end
    # end

    # Override `resource_params` if you want to transform the submitted
    # data before it's persisted. For example, the following would turn all
    # empty values into nil values. It uses other APIs such as `resource_class`
    # and `dashboard`:
    #
    # def resource_params
    #   params.require(resource_class.model_name.param_key).
    #     permit(dashboard.permitted_attributes).
    #     transform_values { |value| value == "" ? nil : value }
    # end

    # See https://administrate-prototype.herokuapp.com/customizing_controller_actions
    # for more information
  end
end

app/controllers/chart_presets_controller.rb
class ChartPresetsController < ApplicationController
  layout 'dashboard'
  before_action :set_chart_preset, only: %i[ show edit update destroy ]

  # GET /chart_presets or /chart_presets.json
  def index
    @chart_presets = ChartPreset.all
    @chart_results = ChartResult.last(10)
  end

  # GET /chart_presets/1 or /chart_presets/1.json
  def show
  end

  # GET /chart_presets/new
  def new
    @chart_preset = ChartPreset.new
  end

  # GET /chart_presets/1/edit
  def edit
  end

  # POST /chart_presets or /chart_presets.json
  def create
    @chart_preset = ChartPreset.new(chart_preset_params)

    respond_to do |format|
      if @chart_preset.save
        format.html { redirect_to chart_preset_url(@chart_preset), notice: "Chart preset was successfully created." }
        format.json { render :show, status: :created, location: @chart_preset }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @chart_preset.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /chart_presets/1 or /chart_presets/1.json
  def update
    respond_to do |format|
      if @chart_preset.update(chart_preset_params)
        format.html { redirect_to chart_preset_url(@chart_preset), notice: "Chart preset was successfully updated." }
        format.json { render :show, status: :ok, location: @chart_preset }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @chart_preset.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /chart_presets/1 or /chart_presets/1.json
  def destroy
    @chart_preset.destroy

    respond_to do |format|
      format.html { redirect_to chart_presets_url, notice: "Chart preset was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_chart_preset
      @chart_preset = ChartPreset.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def chart_preset_params
      params.require(:chart_preset).permit(:title, :description_content, :instruction_payload, :translation_keys)
    end
end

app/helpers/chart_presets_helper.rb
module ChartPresetsHelper
end

app/views/chart_presets/_chart_preset.html.erb
<div id="<%= dom_id chart_preset %>">
  <p class="my-5">
    <strong class="block font-medium mb-1">Title:</strong>
    <%= chart_preset.title %>
  </p>

  <p class="my-5">
    <strong class="block font-medium mb-1">Description content:</strong>
    <%= chart_preset.description_content %>
  </p>

  <p class="my-5">
    <strong class="block font-medium mb-1">Instruction payload:</strong>
    <%= chart_preset.instruction_payload %>
  </p>

  <p class="my-5">
    <strong class="block font-medium mb-1">Translation keys:</strong>
    <%= chart_preset.translation_keys %>
  </p>

  <% if action_name != "show" %>
    <%= link_to "Show this chart preset", chart_preset, class: "rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
    <%= link_to 'Edit this chart preset', edit_chart_preset_path(chart_preset), class: "rounded-lg py-3 ml-2 px-5 bg-gray-100 inline-block font-medium" %>
    <hr class="mt-6">
  <% end %>
</div>

app/views/chart_presets/_form.html.erb
<%= form_with(model: chart_preset, class: "contents") do |form| %>
  <% if chart_preset.errors.any? %>
    <div id="error_explanation" class="bg-red-50 text-red-500 px-3 py-2 font-medium rounded-lg mt-3">
      <h2><%= pluralize(chart_preset.errors.count, "error") %> prohibited this chart_preset from being saved:</h2>

      <ul>
        <% chart_preset.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="my-5">
    <%= form.label :title %>
    <%= form.text_field :title, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="my-5">
    <%= form.label :description_content %>
    <%= form.text_area :description_content, rows: 4, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="my-5">
    <%= form.label :instruction_payload %>
    <%= form.text_field :instruction_payload, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="my-5">
    <%= form.label :translation_keys %>
    <%= form.text_field :translation_keys, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="inline">
    <%= form.submit class: "rounded-lg py-3 px-5 bg-blue-600 text-white inline-block font-medium cursor-pointer" %>
  </div>
<% end %>

app/views/chart_presets/edit.html.erb
<div class="mx-auto md:w-2/3 w-full">
  <h1 class="font-bold text-4xl">Editing chart preset</h1>

  <%= render "form", chart_preset: @chart_preset %>

  <%= link_to "Show this chart preset", @chart_preset, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
  <%= link_to "Back to chart presets", chart_presets_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
</div>

app/views/chart_presets/index.html.erb
<div class="flex flex-col space-y-8">
  <% if notice.present? %>
    <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice"><%= notice %></p>
  <% end %>

    <!-- First Row -->
    <div class="grid grid-cols-1 md:grid-cols-4 xl:grid-cols-5 px-4 xl:p-0 gap-y-4 md:gap-6">
        <div
            class="col-span-12 p-6 rounded-2xl bg-gradient-to-r from-blue-500 to-blue-800 flex flex-col justify-between">
            <div class="flex flex-col">
                <p class="text-white font-bold">Lorem ipsum dolor sit amet</p>
                <p class="mt-1 text-xs md:text-sm text-gray-50 font-light leading-tight max-w-sm">
                    Lorem ipsum dolor sit amet consectetur adipisicing elit. Odio soluta saepe consequuntur
                    facilis ab a. Molestiae ad saepe assumenda praesentium rem dolore? Exercitationem, neque
                    obcaecati?
                </p>
            </div>
            <div class="flex justify-between items-end">
                <a href="#"
                    class="bg-blue-800 px-4 py-3 rounded-lg text-white text-xs tracking-wider font-semibold hover:bg-blue-600 hover:text-white">
                    Learn More
                </a>
                <img src="assets/calendar.png" alt="calendar" class="w-auto h-24 object-cover">
            </div>
        </div>

    </div>
    <!-- End First Row -->
    <!-- Start Third Row -->
    <div class="grid grid-cols-1 md:grid-cols-5 items-start px-4 xl:p-0 gap-y-4 md:gap-6">
        <div class="col-start-1 col-end-5">
            <h2 class="text-xs md:text-sm text-gray-800 font-bold tracking-wide">Generate</h2>
        </div>
        <div class="col-span-2 bg-white p-6 rounded-xl border border-gray-50 flex flex-col space-y-6">
            <div class="col-span-1 md:col-span-2 lg:col-span-4 flex justify-between">
                <h2 class="text-xs md:text-sm text-gray-700 font-bold tracking-wide md:tracking-wider">
                    Chart Presets</h2>
            </div>
            <% @chart_presets.each do |chart_preset| %>
            <div class="bg-white p-6 rounded-xl border border-gray-50">
                <div class="flex justify-between items-start">
                    <div class="flex flex-col">
                        <p class="text-xs text-gray-600 tracking-wide"><%= chart_preset.title %></p>
                        <span class="mt-4 text-xs text-gray-500"><%= chart_preset.description_content %></span>
                    </div>
                    <div class="bg-blue-500 p-2 md:p-1 xl:p-2 rounded-md">
                    <%= link_to chart_preset_path(chart_preset) do %>
                        <%= image_tag "dish-2.png", class: "w-auto h-8 md:h-6 xl:h-8 object-cover" %>
                    <% end %>
                    </div>
                </div>
            </div>
            <% end %>
        </div>
        <div class="col-span-3 bg-white p-6 rounded-xl border border-gray-50 flex flex-col space-y-6">
            <div class="flex justify-between items-center">
                <h2 class="text-sm text-gray-600 font-bold tracking-wide">Latest Dashboards</h2>
            </div>
            <ul class="divide-y-2 divide-gray-100 overflow-x-auto w-full">
                <% @chart_results.each do |chart_result| %>
                    <li class="py-3 flex justify-between text-sm text-gray-500 font-semibold">
                        <p class="px-4 text-gray-600"> <%= chart_result.created_at.strftime("%e %b %Y %H:%M:%S%p") %></p>
                        <p class="px-4 tracking-wider"> <%= truncate(chart_result.chart_preset.title , :length => 60) %></p>
                        <p class="px-4 text-blue-600"> <%= link_to "View Dashboard", chart_result.response_link, target: "_blank" %></p>
                    </li>
                <% end %>
            </ul>
        </div>
    </div>
    <!-- End Third Row -->
</div>

app/views/chart_presets/new.html.erb
<div class="mx-auto md:w-2/3 w-full">
  <h1 class="font-bold text-4xl">New chart preset</h1>

  <%= render "form", chart_preset: @chart_preset %>

  <%= link_to 'Back to chart presets', chart_presets_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
</div>

app/views/chart_presets/show.html.erb
<% if notice.present? %>
  <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice"><%= notice %></p>
<% end %>

<!-- This example requires Tailwind CSS v2.0+ -->
<div class="bg-white shadow overflow-hidden sm:rounded-lg">
  <div class="px-4 py-5 sm:px-6">
    <h3 class="text-lg leading-6 font-medium text-gray-900">Chart Preset Settings</h3>
    <%= link_to 'Generate Dashboard', new_chart_preset_chart_result_path(@chart_preset), class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %> | <%= link_to 'Back to Presets', chart_presets_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
  </div>
  <div class="border-t border-gray-200">
    <dl>
      <div class="bg-gray-50 px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
        <dt class="text-sm font-medium text-gray-500">Title</dt>
        <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2"><%= @chart_preset.title %></dd>
      </div>
      <div class="bg-white px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
        <dt class="text-sm font-medium text-gray-500">Description content:</dt>
        <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2"><%= @chart_preset.description_content %></dd>
      </div>
      <div class="bg-gray-50 px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
        <dt class="text-sm font-medium text-gray-500">Instruction payload:</dt>
        <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2"> <%= @chart_preset.instruction_payload %></dd>
      </div>
      <div class="bg-white px-4 py-5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
        <dt class="text-sm font-medium text-gray-500">Chart Results</dt>
        <dd class="mt-1 text-sm text-gray-900 sm:mt-0 sm:col-span-2">
          <ul role="list" class="border border-gray-200 rounded-md divide-y divide-gray-200">
           <% for chart_result in @chart_preset.chart_results %>
            <li class="pl-3 pr-4 py-3 flex items-center justify-between text-sm">
              <div class="w-0 flex-1 flex items-center">
                <!-- Heroicon name: solid/paper-clip -->
                <svg class="flex-shrink-0 h-5 w-5 text-gray-400" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                  <path fill-rule="evenodd" d="M8 4a3 3 0 00-3 3v4a5 5 0 0010 0V7a1 1 0 112 0v4a7 7 0 11-14 0V7a5 5 0 0110 0v4a3 3 0 11-6 0V7a1 1 0 012 0v4a1 1 0 102 0V7a3 3 0 00-3-3z" clip-rule="evenodd" />
                </svg>
                <span class="ml-2 flex-1 w-0 truncate"> <%= chart_result.created_at.strftime("%e %b %Y %H:%M:%S%p") %> </span>
              </div>
              <div class="ml-4 flex-shrink-0">
                <%= link_to "View Dashboard", chart_result.response_link, target: "_blank", class: "font-medium text-indigo-600 hover:text-indigo-500" %>
              </div>
            </li>
          <% end %>
          </ul>
        </dd>
      </div>
       
    </dl>
  </div>
</div>